Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class Folder

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.PublicObject
                  oracle.ifs.beans.TiePublicObject
                      oracle.ifs.beans.Folder

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, PublicObjectInterface, Traceable

Direct Known Subclasses:
  TieFolder

    public class Folder

extends TiePublicObject

The Folder class represents Folders in the iFS server. A Folder can contain references to any PublicObjects.

To access PublicObjects in a folder use `getItems()`.

(Published)

Field Summary
`static java.lang.String` | `CLASS_NAME` This class name for this class.
`static int` | `SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST` FolderDepth option for Folder.free(def).
`static int` | `SYSTEMOPTIONVALUE_FOLDER_DEPTH_MUST_BE_EMPTY` FolderDepth option for Folder.free(def).
`static int` | `SYSTEMOPTIONVALUE_FOLDER_DEPTH_NONE` FolderDepth option for Folder.free(def).

Fields inherited from class oracle.ifs.beans.PublicObject
`ACL_ATTRIBUTE, CREATEDATE_ATTRIBUTE, CREATOR_ATTRIBUTE, DELETOR_ATTRIBUTE, DESCRIPTION_ATTRIBUTE, EXPIRATIONDATE_ATTRIBUTE, FAMILY_ATTRIBUTE, FLAG_CATEGORY_EXISTS, FLAG_CONFIGURATIONCATEGORY_EXISTS, FLAG_MARKED, FLAG_NOINFERIOR, FLAG_NOSELECT, FLAG_NTFS_ARCHIVE, FLAG_NTFS_HIDDEN, FLAG_NTFS_READONLY, FLAG_NTFS_SYSTEM, FLAG_UNMARKED, FLAGS_ATTRIBUTE, LASTMODIFIER_ATTRIBUTE, LASTMODIFYDATE_ATTRIBUTE, LOCKENTRIES_ATTRIBUTE, LOCKOBJECT_ATTRIBUTE, NAME_ATTRIBUTE, OWNER_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PRIMARYPARENTFOLDER_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE, RESOLVEDPUBLICOBJECT_ATTRIBUTE, SECURINGPUBLICOBJECT_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session`

Constructor Summary
`protected` | `Folder(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Construct a Folder object - standard variant.

Method Summary
`void` | `addItem(PublicObject item)` Adds an item to the folder.
`void` | `addItem(PublicObject item, FolderRelationshipDefinition def)` Adds an item to the folder.
`void` | `addItems(PublicObject[] objs)` Adds an array of PublicObjects to this Folder.
`protected void` | `auditUpdated(LibraryObjectDefinition lodef)` Creates audit events for the update operation.
`PublicObjectCapabilities` | `capabilities()` Returns the PublicObjectCapabilities delegate which tracks the capabilities of this object.
`boolean` | `checkExistenceOfPublicObjectByPath(java.lang.String path)` Determines whether an item exists at the specified path relative to this Folder.
`protected static Folder` | `constructFolder(LibrarySession sess, S_LibraryObjectData data)` Constructs a Folder object from the S_LibraryObjectData object.
`protected static Folder[]` | `constructFolderArray(LibrarySession sess, java.lang.Long[] ids)` Construct a Folder array from an array of object IDs.
`protected static java.util.Vector` | `constructFolderVector(LibrarySession sess, java.util.Vector vector)` Returns Folder Vector from a Vector of S_FolderData objects.
`Document` | `createSecuredDocument(DocumentDefinition def)` Create a document that is parented to and secured by the target folder.
`java.lang.String` | `createUniqueName(java.lang.String name)` Creates a unique name by appending a number to the given name, preserving the file extension of the name.
`java.lang.String` | `createUniqueName(java.lang.String name, boolean preserveExt)` Creates a unique name by appending a number to the given name.
`boolean` | `exists(java.lang.String path)` Checks if the given path refers to a PublicObject.
`protected int` | `fetchItemCount()` Calculates the item count from the item list.
`protected int` | `fetchSubfolderCount()` Calculates the subfolder count from the item list.
`PublicObject` | `find(java.lang.String path)` Given a Folder and a path relative to that folder, find the public object specified by the path.
`PublicObject` | `findPublicObjectByPath(java.lang.String path)` Finds an item descending from a Folder, as specified by a file-system style path.
`void` | `free(LibraryObjectDefinition def)` Permanently removes this object from the repository, with options.
`java.lang.Long` | `getGlobalAuditEventExpirationPeriod()` Gets the expiration period to use for events in the global AuditSpecification.
`AuditTypeList` | `getGlobalAuditTypeList()` Gets the global AuditTypeList registered for this domain context.
`int` | `getItemCount()` Gets the number of items in this Folder, including both documents and subfolders.
`PublicObject[]` | `getItems()` Gets an array containing this Folder's items.
`PublicObject[]` | `getResolvedItems()` Returns the items in this Folder, resolving each to a Document or a Link.
`SortSpecification` | `getSortSpecification()` Gets the SortSpecification used for getting items from this folder.
`int` | `getSubfolderCount()` Gets the count of subfolders in this folder.
`protected void` | `handleAdminModeChange()` Handles an intra-session admin mode change event.
`protected void` | `handleDefaultFolderOptionChange()` Handles change in the default Folder options.
`void` | `handleEvent(IfsEvent event)` Handles the specified event.
`boolean` | `hasItems()` Returns true if this Folder has any items.
`boolean` | `hasSubfolders()` Gets indication as to whether this folder has any subfolders in it.
`static void` | `initializeSubfolderIndication(LibrarySession session)` Initializes all Folders' indication as to whether they have any subfolders.
`boolean` | `isAuditAdministrator()` Checks if the current user is an Audit admin for the target domain.
`protected boolean` | `isValidEventType(AuditEvent event)` Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.
`boolean` | `isValidNameForNewObject(java.lang.String name)` Returns true if the specified name can be used for a new object in the target folder.
`void` | `lock(LockObjectDefinition ldef, FolderDefinition fdef)` Constructs a new lockobject from the definition and sets it as the value of the LockObject attribute on the PO.
`void` | `lock(LockObject lobj, FolderDefinition fdef)` Sets the value of the LockObject attribute of the folder.
`void` | `moveItems(PublicObject[] objs, Folder addToFolder)` Moves the specified array of PublicObjects from this Folder to the passed Folder.
`PublicObject[]` | `newGetItems()` Gets an array containing this Folder's items.
`protected void` | `postCreate(LibraryObjectDefinition lodef)` Extensibility point to perform actions after the creation of a PublicObject.
`protected void` | `preFree(LibraryObjectDefinition lodef)` Extensibility point to perform actions prior to the permanent deletion ("free") of a object.
`void` | `removeAllItems()` Removes all items from this Folder.
`void` | `removeItem(PublicObject item)` Removes the first reference to an item from this Folder without altering the item.
`void` | `removeItem(PublicObject item, PublicObjectDefinition def)` Removes the first reference to an item from this Folder without altering the item.
`void` | `removeItems(PublicObject[] objs)` Removes the passed array of PublicObjects from this Folder.
`protected void` | `reportFolderCreated()` Audits a Folder create operation.
`protected void` | `reportFolderFreed()` Audits a Folder free operation.
`protected void` | `reportFolderItemAdded(PublicObject item)` Audits a Folder addItem operation.
`protected void` | `reportFolderItemRemoved(PublicObject item)` Audits a Folder removeItem operation.
`void` | `resetItems()` Clears locally cached item counts.
`protected SortSpecification` | `resolveSortSpecification(LibrarySession session)` Forces the SortSpecification (if specified) to be resolved and verified.
`void` | `setDomainVisibleSecurity(PublicObjectDefinition def)` Set "domain visible" security information in the specified PublicObjectDefinition.
`void` | `setSortSpecification(SortSpecification sort)` Sets the SortSpecification used for getting items from this folder.
`void` | `unlock(FolderDefinition fdef)` Releases the lock on the object.
`protected static Folder[]` | `vectorToFolderArray(java.util.Vector vector)` Convert a Vector of Folder to an array of Folder.
`void` | `verifyValidAuditDomain()` Verifies that the target object is a valid Audit Domain.

Methods inherited from class oracle.ifs.beans.PublicObject
`addAccess, addCategory, addFlags, addRelationship, auditPublicObjectLocked, auditPublicObjectUnlocked, canAcquireManualLock, canReleaseDavLock, canReleaseLock, canReleaseManualLock, checkAuditViewCapability, checkCapabilities, checkCapability, checkEffectiveAccess, checkEffectiveAccess, checkLockAccess, checkVersioned, clearFlags, constructPublicObject, constructPublicObjectArray, constructPublicObjectVector, copy, coreAutoFolderingEnabled, createCategories, createDedicatedPolicyPropertyBundle, delete, deriveEffectiveAccessLevel, getAcl, getAllFolderPaths, getAllFolderPaths, getAllFolderPaths, getAnyFolderPath, getAnyFolderPath, getAnyFolderPath, getCapabilities, getCategories, getCategories, getCategories, getCategories, getCategories, getCategory, getConsumedStorage, getCreateDate, getCreator, getDefaultAccessLevel, getDeletor, getDescription, getEffectiveAccessLevel, getEffectiveAccessLevel, getExpirationDate, getFamily, getFirstVersion, getFlags, getFolderReferences, getFolderReferences, getFolderReferencesSortSpecification, getLastModifier, getLastModifyDate, getLastVersion, getLeftwardRelationshipObjects, getLeftwardRelationshipObjects, getLeftwardRelationships, getLeftwardRelationships, getLeftwardRelationshipsCount, getLeftwardRelationshipsCount, getLinks, getLockEntries, getLockEntries, getLockObject, getLockRestrictions, getLockTypeAuditProperties, getNextVersion, getOwner, getPolicyBundle, getPolicyLists, getPreviousVersion, getPrimaryFolderPath, getPrimaryParentFolder, getPrimaryParentFolder, getReservationComment, getReservationDate, getReservor, getResolvedPublicObject, getRestrictingLockEntries, getRightwardRelationshipObjects, getRightwardRelationshipObjects, getRightwardRelationships, getRightwardRelationships, getSecuringPublicObject, getSingletonVersionDescription, getVersionNumber, getVersions, getVersionSeries, getWorkingCopy, grantAccess, handleCopy, handleCreate, handleUnlockAll, hasCategories, hasConfigurationCategories, hasNameAttribute, isDeleted, isLatestVersion, isLocked, isLockingSupported, isOwner, isReserved, isReservedByCurrentUser, isVersionable, isVersioned, isWorkingCopy, listLeftwardRelationships, listRightwardRelationships, lock, lock, lock, lock, newVersion, postCopy, postUpdate, preCopy, preCreate, preUpdate, putPolicy, reassociateLinks, removeAllPolicies, removePolicy, removePolicy, removeRelationship, reserveNext, resetFolderReferences, resolveFolderReferenceSortSpecification, revokeAccess, revokeAllAccess, setAcl, setDescription, setExpirationDate, setFlags, setFolderReferencesSortSpecification, setLockEntries, setLockEntrySecurity, setOwner, setOwnerByName, setPolicyBundle, setPolicyLists, setSecuringPublicObject, toPublicObjectArray, undelete, unlock, unlock, unlockAll, unReserve, updateFlags, updateLock, vectorPublicObjectElement, vectorToPublicObjectArray, verifyDeleteCapability, verifyLockCapability, verifyUnlockCapability, verifyVersionSeries`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getLabel, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleFree, handleUpdate, hashCode, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, prePostAuditEvent, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, validatePropertyValues, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `Folder`
  This class name for this class. Useful for methods that take a class name argument.

  See Also:
    Constant Field Values
  (Published)

### SYSTEMOPTIONVALUE_FOLDER_DEPTH_NONE

    public static final int SYSTEMOPTIONVALUE_FOLDER_DEPTH_NONE

  Description copied from class: `Folder`
  FolderDepth option for Folder.free(def). Frees only the folder, no referenced objects are freed.
  FolderDepth option for Folder.lock(def) and Folder.unlock(def) Locks/UnLocks only the folder and no referenced objects are affected

  See Also:
    Constant Field Values
  (Published)

### SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST

    public static final int SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST

  Description copied from class: `Folder`
  FolderDepth option for Folder.free(def). Frees all objects referenced by this folder. If those objects are folders, the DEEPEST option is passed on to them (causing a deep free cascade).
  FolderDepth option for Folder.lock(def) and Folder.unlock(def) The folder as well as all the referenced objects are locked/unlocked

  See Also:
    Constant Field Values
  (Published)

### SYSTEMOPTIONVALUE_FOLDER_DEPTH_MUST_BE_EMPTY

    public static final int SYSTEMOPTIONVALUE_FOLDER_DEPTH_MUST_BE_EMPTY

  Description copied from class: `Folder`
  FolderDepth option for Folder.free(def). When this option is set, the free is forbidden if the folder is not empty.

  See Also:
    Constant Field Values
  (Published)

Constructor Detail

### Folder

    protected Folder(LibrarySession session,
                     java.lang.Long id,
                     java.lang.Long classId,
                     S_LibraryObjectData data)
              throws IfsException

  Construct a Folder object - standard variant.

  Parameters:
    `session` - the session
    `id` - the id
    `classId` - the class id
    `data` - the Folder data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### capabilities

    public PublicObjectCapabilities capabilities()

  Description copied from class: `Folder`
  Returns the PublicObjectCapabilities delegate which tracks the capabilities of this object.

  Overrides:
    `capabilities` in class `PublicObject`
  Returns:
    an instance of TieFolderCapabilities

### postCreate

    protected void postCreate(LibraryObjectDefinition lodef)
                       throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions after the creation of a PublicObject.

  This assumes that a transaction context has already been established.

  Overrides:
    `postCreate` in class `PublicObject`
  Parameters:
    `lodef` - object definition that was used to create the object
  Throws:
    `IfsException` - if the operation fails

### preFree

    protected void preFree(LibraryObjectDefinition lodef)
                    throws IfsException

  Description copied from class: `PublicObject`
  Extensibility point to perform actions prior to the permanent deletion ("free") of a object.

  Override to free all existing categories, in such a way that the PO doesn't get updated for each category free.

  Overrides:
    `preFree` in class `PublicObject`
  Parameters:
    `lodef` - object definition used to hold options related to the free operation
  Throws:
    `IfsException` - if operation fails.

### isValidEventType

    protected boolean isValidEventType(AuditEvent event)
                                throws IfsException

  Description copied from class: `Folder`
  Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.

  Overrides:
    `isValidEventType` in class `LibraryObject`
  Parameters:
    `event` - the event being posted on this object
  Returns:
    true if the type is consistent; false otherwise
  Throws:
    `IfsException` - if the operation fails

### auditUpdated

    protected void auditUpdated(LibraryObjectDefinition lodef)
                         throws IfsException

  Description copied from class: `Folder`
  Creates audit events for the update operation.

  Overrides:
    `auditUpdated` in class `LibraryObject`
  Parameters:
    `lodef` - The update definition
  Throws:
    `IfsException` - if the operation fails

### reportFolderCreated

    protected void reportFolderCreated()
                                throws IfsException

  Description copied from class: `Folder`
  Audits a Folder create operation.

  Throws:
    `IfsException` - if the operation fails

### reportFolderFreed

    protected void reportFolderFreed()
                              throws IfsException

  Description copied from class: `Folder`
  Audits a Folder free operation.

  Throws:
    `IfsException` - if the operation fails

### reportFolderItemAdded

    protected void reportFolderItemAdded(PublicObject item)
                                  throws IfsException

  Description copied from class: `Folder`
  Audits a Folder addItem operation.

  Parameters:
    `item` - the item being added
  Throws:
    `IfsException` - if the operation fails

### reportFolderItemRemoved

    protected void reportFolderItemRemoved(PublicObject item)
                                    throws IfsException

  Description copied from class: `Folder`
  Audits a Folder removeItem operation.

  Parameters:
    `item` - the item being removed
  Throws:
    `IfsException` - if the operation fails

### getSortSpecification

    public SortSpecification getSortSpecification()
                                           throws IfsException

  Description copied from class: `Folder`
  Gets the SortSpecification used for getting items from this folder.

  Returns:
    this Folder's SortSpecification.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setSortSpecification

    public void setSortSpecification(SortSpecification sort)
                              throws IfsException

  Description copied from class: `Folder`
  Sets the SortSpecification used for getting items from this folder.

  Parameters:
    `sort` - this Folder's SortSpecification
  Throws:
    `IfsException` - if operation fails.
  (Published)

### resolveSortSpecification

    protected SortSpecification resolveSortSpecification(LibrarySession session)
                                                  throws IfsException

  Description copied from class: `Folder`
  Forces the SortSpecification (if specified) to be resolved and verified.

  Parameters:
    `session` - the current LibrarySession
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### find

    public PublicObject find(java.lang.String path)
                      throws IfsException

  Description copied from class: `Folder`
  Given a Folder and a path relative to that folder, find the public object specified by the path.

  If there is no PublicObject at the specified path, returns null.

  If there is an object, but the requestor does not have access to it, throw an exception indicating access denied. The specified path must not start with a path delimiter.

  If the path is null or the empty string, returns null.

  Parameters:
    `path` - the String containing the path to check, relative to the target folder
  Returns:
    the PublicObject found, or null if no object exists at the specified path
  Throws:
    `IfsException` - if the operation fails
  (Published)

### findPublicObjectByPath

    public PublicObject findPublicObjectByPath(java.lang.String path)
                                        throws IfsException

  Description copied from class: `Folder`
  Finds an item descending from a Folder, as specified by a file-system style path. For example, if the user specifies "eboa/playoff.txt" as the path, the server will search for a folder named "eboa" that is related to the target folder via a FolderPathRelationship, and if found, will look for an object named "playoff.txt" related to that folder via a FolderPathRelationship. The supplied path parameter cannot be an absolute path (cannot begin with a "/"). For absolute paths, use `FolderUtilities.findObjectByAbsolutePath`.

  Parameters:
    `path` - the folder path to the desired item.
  Returns:
    the item reachable by the specified path
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### exists

    public boolean exists(java.lang.String path)
                   throws IfsException

  Description copied from class: `Folder`
  Checks if the given path refers to a PublicObject.

  Parameters:
    `path` - the path to check.
  Returns:
    true if the path refers to a PublicObject; false if it does not.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### checkExistenceOfPublicObjectByPath

    public boolean checkExistenceOfPublicObjectByPath(java.lang.String path)
                                               throws IfsException

  Description copied from class: `Folder`
  Determines whether an item exists at the specified path relative to this Folder. If the path specified contains subfolder references, then this method returns false if any of those subfolder references are not discoverable by the caller. The supplied path parameter cannot be an absolute path (cannot begin with a "/"). If you have to use an absoulte path, doing a relative path (absolute path minus the leading slash) based invocation on the root folder gets the desired result.

  Parameters:
    `path` - path the folder path to the desired item.
  Returns:
    true if an object exists at the specified path.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### createUniqueName

    public java.lang.String createUniqueName(java.lang.String name)
                                      throws IfsException

  Description copied from class: `Folder`
  Creates a unique name by appending a number to the given name, preserving the file extension of the name.

  Parameters:
    `name` - the base name to make unique.
  Returns:
    a unique name among the set of items in this folder.
  Throws:
    `IfsException` - if the operation fails

### createUniqueName

    public java.lang.String createUniqueName(java.lang.String name,
                                             boolean preserveExt)
                                      throws IfsException

  Description copied from class: `Folder`
  Creates a unique name by appending a number to the given name.

  Parameters:
    `name` - the base name to make unique.
    `preserveExt` - whether or not to preserve the file extension
  Returns:
    a unique name among the set of items in this folder.
  Throws:
    `IfsException` - if the operation fails

### isValidNameForNewObject

    public boolean isValidNameForNewObject(java.lang.String name)
                                    throws IfsException

  Description copied from class: `Folder`
  Returns true if the specified name can be used for a new object in the target folder.

  Parameters:
    `name` - the name to be checked.
  Returns:
    true if the name is valid for a new object.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getItemCount

    public int getItemCount()
                     throws IfsException

  Description copied from class: `Folder`
  Gets the number of items in this Folder, including both documents and subfolders.

  May returned cached information that does not reflect the actual number of discoverable items. Call `resetItems` first in order to get more accurate information.

  Returns:
    the item count.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### fetchItemCount

    protected int fetchItemCount()
                          throws IfsException

  Description copied from class: `Folder`
  Calculates the item count from the item list.

  The cached folder item count info will be updated as a side-effect of calling this method.

  Returns:
    the item count.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSubfolderCount

    public int getSubfolderCount()
                          throws IfsException

  Description copied from class: `Folder`
  Gets the count of subfolders in this folder.

  May returned cached information that does not reflect the actual number of discoverable subfolders. Call `resetItems` first in order to get more accurate information.

  Returns:
    the subfolder item count.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### fetchSubfolderCount

    protected int fetchSubfolderCount()
                               throws IfsException

  Description copied from class: `Folder`
  Calculates the subfolder count from the item list.

  The cached folder item count info will be updated as a side-effect of calling this method.

  Returns:
    the item count.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### hasItems

    public boolean hasItems()
                     throws IfsException

  Description copied from class: `Folder`
  Returns true if this Folder has any items.

  May returned cached information that does not reflect the actual number of discoverable items. Call `resetItems` first in order to get more accurate information.

  Returns:
    true if this Folder has any items
  Throws:
    `IfsException` - if the operation fails.

### hasSubfolders

    public boolean hasSubfolders()
                          throws IfsException

  Description copied from class: `Folder`
  Gets indication as to whether this folder has any subfolders in it.

  May returned cached information that does not reflect the actual number of discoverable subfolders. Call `resetItems` first in order to get more accurate information.

  Returns:
    the subfolder item count
  Throws:
    `IfsException` - if operation fails.
  (Published)

### resetItems

    public void resetItems()
                    throws IfsException

  Description copied from class: `Folder`
  Clears locally cached item counts.

  Call this prior to any of the accessors related to item counts, to get accurate counts.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getItems

    public PublicObject[] getItems()
                            throws IfsException

  Description copied from class: `Folder`
  Gets an array containing this Folder's items.

  Returns null if no items in this Folder.

  Returns:
    the Folder's items. Returns null if no items
  Throws:
    `IfsException` - if the operation fails
  (Published)

### newGetItems

    public PublicObject[] newGetItems()
                               throws IfsException

  Description copied from class: `Folder`
  Gets an array containing this Folder's items. Returns null if no items in this Folder.

  Returns:
    the Folder's items. Returns null if no items.
  Throws:
    `IfsException` - if the operation fails.
  (Unpublished)

### getResolvedItems

    public PublicObject[] getResolvedItems()
                                    throws IfsException

  Description copied from class: `Folder`
  Returns the items in this Folder, resolving each to a Document or a Link.

  The resolving process returns the correct version of a Family based on the session's version selection mode. By default, this is the latest version.

  Returns:
    the resolved items in this Folder (Document or Link objects); returns an empty array if there are no resolved items in this Folder.
  Throws:
    `IfsException` - if the operation fails

### addItem

    public void addItem(PublicObject item)
                 throws IfsException

  Description copied from class: `Folder`
  Adds an item to the folder.

  Parameters:
    `item` - the item to be added.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### addItem

    public void addItem(PublicObject item,
                        FolderRelationshipDefinition def)
                 throws IfsException

  Description copied from class: `Folder`
  Adds an item to the folder.

  Parameters:
    `item` - the item to be added.
    `def` - the FolderRelationshipDefinition.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### createSecuredDocument

    public Document createSecuredDocument(DocumentDefinition def)
                                   throws IfsException

  Description copied from class: `Folder`
  Create a document that is parented to and secured by the target folder.

  Parameters:
    `def` - the document definition
  Returns:
    the newly created document
  Throws:
    `IfsException` - if the operation fails

### removeItem

    public void removeItem(PublicObject item)
                    throws IfsException

  Description copied from class: `Folder`
  Removes the first reference to an item from this Folder without altering the item.

  Parameters:
    `item` - the item to be removed from the folder.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### removeItem

    public void removeItem(PublicObject item,
                           PublicObjectDefinition def)
                    throws IfsException

  Description copied from class: `Folder`
  Removes the first reference to an item from this Folder without altering the item.

  Parameters:
    `item` - the item to be removed from the folder.
    `def` - the options to be used in this operation.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### addItems

    public void addItems(PublicObject[] objs)
                  throws IfsException

  Description copied from class: `Folder`
  Adds an array of PublicObjects to this Folder.

  Note that if any of the items fail to be added due to security reasons etc. the entire operation is rolled back and none of the changes take effect.

  Parameters:
    `objs` - PublicObjects to be added.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### removeItems

    public void removeItems(PublicObject[] objs)
                     throws IfsException

  Description copied from class: `Folder`
  Removes the passed array of PublicObjects from this Folder.

  If any of the items fail to be removed due to security reasons etc. this method will rollback all operations and none of the changes take effect

  Parameters:
    `objs` - PublicObjects to be removed.
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### removeAllItems

    public void removeAllItems()
                        throws IfsException

  Description copied from class: `Folder`
  Removes all items from this Folder.

  If any of the items fail to be removed due to security reasons etc. this method will rollback all operations and none of the changes take effect

  Throws:
    `IfsException` - if the operation fails.
  (Unpublished)

### free

    public void free(LibraryObjectDefinition def)
              throws IfsException

  Description copied from class: `Folder`
  Permanently removes this object from the repository, with options.

  If a null definition is specified, a default definition is used.

  Overrides:
    `free` in class `PublicObject`
  Parameters:
    `def` - Context for the free operation.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### moveItems

    public void moveItems(PublicObject[] objs,
                          Folder addToFolder)
                   throws IfsException

  Description copied from class: `Folder`
  Moves the specified array of PublicObjects from this Folder to the passed Folder.

  If any of the items fail to be moved due to security reasons etc. this method will throw an exception and roll back

  Parameters:
    `objs` - PublicObjects to be moved.
    `addToFolder` - destination Folder
  Throws:
    `IfsException` - if the operation fails.
  (Published)

### lock

    public void lock(LockObject lobj,
                     FolderDefinition fdef)
              throws IfsException

  Description copied from class: `Folder`
  Sets the value of the LockObject attribute of the folder.

  A user must have setAttribute permission on the object to perform this operation. see the JavaDoc for LockObject for additional permission requirements for the different lock states.
  The folder definition is used for deep locking. If the def has the FolderDepth option SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST set, then all the items under this folder that the user has access to will be locked and will share the same lockobject as the parent folder. The entire operation is performed in a transaction to ensure complete or no success.

  Parameters:
    `lobj` - LockObject the existing lockobject to be used
    `fdef` - FolderDefinition the definition that contains the depth option
  Throws:
    `IfsException` - if operation fails.
  (Published)

### lock

    public void lock(LockObjectDefinition ldef,
                     FolderDefinition fdef)
              throws IfsException

  Description copied from class: `Folder`
  Constructs a new lockobject from the definition and sets it as the value of the LockObject attribute on the PO.

  A user must have SetAttribute permission on the object to perform this operation. See the JavaDoc for LockObject for additional permission requirements for the various lockstates.
  The folder definition is used for deep locking. If the def has the FolderDepth option SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST set then all the items under this folder that the user has access to will be locked and will share the same lockobject as the parent folder. The entire operation is performed in a transaction to ensure complete or no success.

  Parameters:
    `ldef` - LockObjectDefinition to be used.This will construct a new lockobject
    `fdef` - FolderDefinition the definition that contains the depth option
  Throws:
    `IfsException` - if operation fails.
  (Published)

### unlock

    public void unlock(FolderDefinition fdef)
                throws IfsException

  Description copied from class: `Folder`
  Releases the lock on the object.

  A user must have SetAttribute permissions on the object to perform this operation. See the JavaDoc for LockObject for additional permission requirements for other lock states. This will set the LockObject attribute on PO to null
  The folder definition is used for deep locking. If the def has the FolderDepth option SYSTEMOPTIONVALUE_FOLDER_DEPTH_DEEPEST set, then all the items under this folder that the user has access to will be unlocked. The entire operation is performed in a transaction to ensure complete or no success.

  Parameters:
    `fdef` - FolderDefinition the definition that contains the depth option
  Throws:
    `IfsException` - if operation fails.
  (Published)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `Folder`
  Handles the specified event.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Overrides:
    `handleEvent` in class `LibraryObject`
  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleDefaultFolderOptionChange

    protected void handleDefaultFolderOptionChange()
                                            throws IfsException

  Description copied from class: `Folder`
  Handles change in the default Folder options.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### handleAdminModeChange

    protected void handleAdminModeChange()
                                  throws IfsException

  Description copied from class: `Folder`
  Handles an intra-session admin mode change event.

  This class overrides to reset the Items cache.

  Overrides:
    `handleAdminModeChange` in class `LibraryObject`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### verifyValidAuditDomain

    public void verifyValidAuditDomain()
                                throws IfsException

  Description copied from class: `Folder`
  Verifies that the target object is a valid Audit Domain.

  Throws:
    `IfsException` - if the not a valid Audit Domain

### isAuditAdministrator

    public boolean isAuditAdministrator()
                                 throws IfsException

  Description copied from class: `Folder`
  Checks if the current user is an Audit admin for the target domain.

  Returns true if current user is SYSTEM.

  Returns:
    true if the current user has audit admin access
  Throws:
    `IfsException` - if the operation fails

### getGlobalAuditTypeList

    public AuditTypeList getGlobalAuditTypeList()
                                         throws IfsException

  Description copied from class: `Folder`
  Gets the global AuditTypeList registered for this domain context.

  This base class impl just returns the AuditTypeList from the domain PropertyBundle. Subclasses can return something more specific, e.g. in ECM, a Domain property is returned.

  Returns:
    the AuditTypeList registered for global events
  Throws:
    `IfsException` - if the operation fails

### getGlobalAuditEventExpirationPeriod

    public java.lang.Long getGlobalAuditEventExpirationPeriod()
                                                       throws IfsException

  Description copied from class: `Folder`
  Gets the expiration period to use for events in the global AuditSpecification.

  The impl in this base class returns the value stored as a domain property.

  Returns:
    the global event expiration period, or null if no expiration is in effect
  Throws:
    `IfsException` - if the operation fails

### setDomainVisibleSecurity

    public void setDomainVisibleSecurity(PublicObjectDefinition def)
                                  throws IfsException

  Description copied from class: `Folder`
  Set "domain visible" security information in the specified PublicObjectDefinition.

  Overrides base implmentation in Folder,and delegates to a utility method.

  Parameters:
    `def` - set security info will be set on this definition
  Throws:
    `IfsException` - if the operation fails
  (Published)

### initializeSubfolderIndication

    public static void initializeSubfolderIndication(LibrarySession session)
                                              throws IfsException

  Description copied from class: `Folder`
  Initializes all Folders' indication as to whether they have any subfolders.

  Parameters:
    `session` - the session context
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructFolderVector

    protected static java.util.Vector constructFolderVector(LibrarySession sess,
                                                            java.util.Vector vector)
                                                     throws IfsException

  Description copied from class: `Folder`
  Returns Folder Vector from a Vector of S_FolderData objects.

  Parameters:
    `sess` - current LibrarySession
    `vector` - vector of Folder objects
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructFolder

    protected static Folder constructFolder(LibrarySession sess,
                                            S_LibraryObjectData data)
                                     throws IfsException

  Description copied from class: `Folder`
  Constructs a Folder object from the S_LibraryObjectData object.

  Parameters:
    `sess` - current LibrarySession
    `data` - data component
  Returns:
    the folder
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructFolderArray

    protected static Folder[] constructFolderArray(LibrarySession sess,
                                                   java.lang.Long[] ids)
                                            throws IfsException

  Description copied from class: `Folder`
  Construct a Folder array from an array of object IDs. This will throw an exception if any of the IDs cannot be converted into a Folder.

  Parameters:
    `sess` - the requesting session
    `ids` - the array of object IDs
  Returns:
    the array of Folders
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### vectorToFolderArray

    protected static Folder[] vectorToFolderArray(java.util.Vector vector)

  Description copied from class: `Folder`
  Convert a Vector of Folder to an array of Folder.

  Parameters:
    `vector` - Vector of Folder objects
  Returns:
    array of Folder objects that corresponds to Vector
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD